package org.bidib.wizard.comm;

import org.bidib.jbidibc.enumeration.CriticalFunctionEnum;
import org.bidib.wizard.locale.Resources;

public enum CriticalFunctionStatus implements BidibStatus {
    // @formatter:off
    BEGIN(CriticalFunctionEnum.BEGIN, Resources.getString(CriticalFunctionStatus.class, "begin")), END(
        CriticalFunctionEnum.END, Resources.getString(CriticalFunctionStatus.class, "end"));
    // @formatter:on

    private final CriticalFunctionEnum type;

    private final String label;

    CriticalFunctionStatus(CriticalFunctionEnum type, String label) {
        this.type = type;
        this.label = label;
    }

    public CriticalFunctionEnum getType() {
        return type;
    }

    public String toString() {
        return label;
    }

    public static CriticalFunctionStatus valueOf(CriticalFunctionEnum type) {
        CriticalFunctionStatus result = null;

        for (CriticalFunctionStatus e : values()) {
            if (e.type == type) {
                result = e;
                break;
            }
        }
        if (result == null) {
            throw new IllegalArgumentException("cannot map " + type + " to a critical function status");
        }
        return result;
    }
}
