package org.bidib.wizard.comm;

import org.bidib.jbidibc.enumeration.InputPortEnum;

public enum InputPortStatus implements BidibStatus {
    // @formatter:off
    ON(InputPortEnum.ON), OFF(InputPortEnum.OFF);
    // @formatter:on

    private final InputPortEnum type;

    InputPortStatus(InputPortEnum type) {
        this.type = type;
    }

    public InputPortEnum getType() {
        return type;
    }

    public String toString() {
        return type.toString();
    }

    public static InputPortStatus valueOf(InputPortEnum type) {
        InputPortStatus result = null;

        for (InputPortStatus e : values()) {
            if (e.type == type) {
                result = e;
                break;
            }
        }
        if (result == null) {
            throw new IllegalArgumentException("cannot map " + type + " to an input port status");
        }
        return result;
    }
}
