package org.bidib.wizard.comm;

import org.bidib.jbidibc.enumeration.InputEnum;
import org.bidib.wizard.locale.Resources;

public enum InputStatus implements BidibStatus {
    // @formatter:off
    QUERY0(InputEnum.QUERY0, Resources.getString(InputStatus.class, "query0")), QUERY1(InputEnum.QUERY1, Resources
        .getString(InputStatus.class, "query1"));
    // @formatter:on

    private final InputEnum type;

    private final String label;

    InputStatus(InputEnum type, String label) {
        this.type = type;
        this.label = label;
    }

    public InputEnum getType() {
        return type;
    }

    public String toString() {
        return label;
    }

    public static InputStatus valueOf(InputEnum type) {
        InputStatus result = null;

        for (InputStatus e : values()) {
            if (e.type == type) {
                result = e;
                break;
            }
        }
        if (result == null) {
            throw new IllegalArgumentException("cannot map " + type + " to a input status");
        }
        return result;
    }
}
