package org.bidib.wizard.comm;

import org.bidib.jbidibc.enumeration.LightPortEnum;
import org.bidib.wizard.locale.Resources;

public enum LightPortStatus implements BidibStatus {
    // @formatter:off
    ON(LightPortEnum.ON, Resources.getString(LightPortStatus.class, "on")), OFF(LightPortEnum.OFF, Resources.getString(
        LightPortStatus.class, "off")), UP(LightPortEnum.UP, Resources.getString(LightPortStatus.class, "up")), DOWN(
        LightPortEnum.DOWN, Resources.getString(LightPortStatus.class, "down")), NEON(LightPortEnum.NEON, Resources
        .getString(LightPortStatus.class, "neon")), BLINKA(LightPortEnum.BLINKA, Resources.getString(
        LightPortStatus.class, "blinka")), BLINKB(LightPortEnum.BLINKB, Resources.getString(LightPortStatus.class,
        "blinkb")), FLASHA(LightPortEnum.FLASHA, Resources.getString(LightPortStatus.class, "flasha")), FLASHB(
        LightPortEnum.FLASHB, Resources.getString(LightPortStatus.class, "flashb")), DOUBLEFLASH(
        LightPortEnum.DOUBLEFLASH, Resources.getString(LightPortStatus.class, "doubleflash"));
    // @formatter:on

    private final LightPortEnum type;

    private final String label;

    LightPortStatus(LightPortEnum type, String label) {
        this.type = type;
        this.label = label;
    }

    public LightPortEnum getType() {
        return type;
    }

    public String toString() {
        return label;
    }

    public static LightPortStatus valueOf(LightPortEnum type) {
        LightPortStatus result = null;

        for (LightPortStatus e : values()) {
            if (e.type == type) {
                result = e;
                break;
            }
        }
        if (result == null) {
            throw new IllegalArgumentException("cannot map " + type + " to a light port status");
        }
        return result;
    }
}
