package org.bidib.wizard.comm;

import org.bidib.jbidibc.enumeration.MacroEnum;
import org.bidib.wizard.locale.Resources;

public enum MacroStatus implements BidibStatus {
    // @formatter:off
    START(MacroEnum.START, Resources.getString(MacroStatus.class, "start")), STOP(MacroEnum.STOP, Resources.getString(
        MacroStatus.class, "stop")), END(MacroEnum.END, Resources.getString(MacroStatus.class, "end"));
    // @formatter:on

    private final MacroEnum type;

    private final String label;

    MacroStatus(MacroEnum type, String label) {
        this.type = type;
        this.label = label;
    }

    public MacroEnum getType() {
        return type;
    }

    public String toString() {
        return label;
    }

    public static MacroStatus valueOf(MacroEnum type) {
        MacroStatus result = null;

        for (MacroStatus e : values()) {
            if (e.type == type) {
                result = e;
                break;
            }
        }
        if (result == null) {
            throw new IllegalArgumentException("cannot map " + type + " to a macro status");
        }
        return result;
    }
}
