package org.bidib.wizard.comm;

import org.bidib.jbidibc.enumeration.ServoPortEnum;
import org.bidib.wizard.locale.Resources;

public enum ServoPortStatus implements BidibStatus {
    // @formatter:off
    START(ServoPortEnum.START, Resources.getString(ServoPortStatus.class, "start"));
    // @formatter:on

    private final ServoPortEnum type;

    private final String label;

    ServoPortStatus(ServoPortEnum type, String label) {
        this.type = type;
        this.label = label;
    }

    public ServoPortEnum getType() {
        return type;
    }

    public String toString() {
        return label;
    }

    public static ServoPortStatus valueOf(ServoPortEnum type) {
        ServoPortStatus result = null;

        for (ServoPortStatus e : values()) {
            if (e.type == type) {
                result = e;
                break;
            }
        }
        if (result == null) {
            throw new IllegalArgumentException("cannot map " + type + " to a servo port status");
        }
        return result;
    }
}
