package org.bidib.wizard.comm;

import org.bidib.jbidibc.enumeration.SoundPortEnum;
import org.bidib.wizard.locale.Resources;

public enum SoundPortStatus implements BidibStatus {
    // @formatter:off
    START(SoundPortEnum.START, Resources.getString(SoundPortStatus.class, "start"));
    // @formatter:on

    private final SoundPortEnum type;

    private final String label;

    SoundPortStatus(SoundPortEnum type, String label) {
        this.type = type;
        this.label = label;
    }

    public SoundPortEnum getType() {
        return type;
    }

    public String toString() {
        return label;
    }

    public static SoundPortStatus valueOf(SoundPortEnum type) {
        SoundPortStatus result = null;

        for (SoundPortStatus e : values()) {
            if (e.type == type) {
                result = e;
                break;
            }
        }
        if (result == null) {
            throw new IllegalArgumentException("cannot map " + type + " to a sound port status");
        }
        return result;
    }
}
