package org.bidib.wizard.main;

import java.io.File;

import javax.swing.UIManager;

import org.bidib.jbidibc.Bidib;
import org.bidib.wizard.comm.CommunicationFactory;
import org.bidib.wizard.mvc.error.controller.ErrorController;
import org.bidib.wizard.mvc.main.controller.MainController;
import org.bidib.wizard.mvc.preferences.model.Preferences;
import org.slf4j.LoggerFactory;

public class BiDiBWizard {
    public static void main(String[] args) throws Exception {
        // set path to preferences
        Preferences.setPath(new File(System.getProperty("user.home"), ".bidibwizardrc").getPath());

        Preferences.getInstance().reloadLoggerConfiguration();

        // Ensure serial port is initialized before look and feel is set,
        // otherwise Java VM crashes.
        CommunicationFactory.getInstance();

        // system look and feel
        UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());

        // set log file for analyzing
        if (args.length >= 1) {
            LoggerFactory.getLogger(BiDiBWizard.class).info("Set logfile: {}", args[0]);
            Bidib.setLogFile(args[0]);
        }

        // open GUI
        new ErrorController().start();
        new MainController().start();
    }

}
