package org.bidib.wizard.mvc.cvprogrammer.model;

import java.util.Collection;
import java.util.LinkedList;

import org.bidib.wizard.mvc.cvprogrammer.model.listener.ConfigVariableListener;

public class CvProgrammerModel {
    private final Collection<ConfigVariableListener> listeners = new LinkedList<ConfigVariableListener>();

    private int number = 1;

    private int value = 0;

    public void addConfigVariableListener(ConfigVariableListener l) {
        listeners.add(l);
    }

    public void removeConfigVariableListener(ConfigVariableListener l) {
        listeners.remove(l);
    }

    public int getNumber() {
        return number;
    }

    public void setNumber(int number) {
        if (this.number != number) {
            this.number = number;
            fireNumberChanged(number);
        }
    }

    public int getValue() {
        return value;
    }

    public void setValue(int value) {
        if (this.value != value) {
            this.value = value;
            fireValueChanged(value);
        }
    }

    private void fireNumberChanged(int number) {
        for (ConfigVariableListener l : listeners) {
            l.numberChanged(number);
        }
    }

    private void fireValueChanged(int value) {
        for (ConfigVariableListener l : listeners) {
            l.valueChanged(value);
        }
    }
}
