package org.bidib.wizard.mvc.main.model;

import org.bidib.wizard.locale.Resources;
import org.bidib.wizard.mvc.main.model.listener.PortListener;

public class InputPortTableModel extends SimplePortTableModel {
    private static final long serialVersionUID = 6623704562734557353L;

    private String[] columnNames =
        { Resources.getString(getClass(), "label"), Resources.getString(getClass(), "status"), null };

    public InputPortTableModel(MainModel model) {
        setColumnIdentifiers(columnNames);
        model.addInputPortListener(new PortListener() {
            @Override
            public void labelChanged(Port port, String label) {
            }

            @Override
            public void statusChanged(Port port, Enum<?> status) {
                for (int row = 0; row < getRowCount(); row++) {
                    if (port == getValueAt(row, 2)) {
                        setValueAt(port, row, 1);
                    }
                }
            }
        });
    }

    public void addRow(Port port) {
        if (port != null) {
            Object[] rowData = new Object[columnNames.length];

            rowData[0] = port.toString();
            rowData[1] = port;
            rowData[2] = port;
            addRow(rowData);
        }
    }

    @Override
    public boolean isCellEditable(int row, int column) {
        return column == 0;
    }
}
