package org.bidib.wizard.mvc.main.model;

import java.beans.IntrospectionException;
import java.beans.Introspector;
import java.beans.PropertyDescriptor;
import java.beans.XMLDecoder;
import java.beans.XMLEncoder;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.zip.GZIPInputStream;
import java.util.zip.GZIPOutputStream;

import org.bidib.wizard.comm.LightPortStatus;

public class LightPort extends Port {
    static {
        try {
            PropertyDescriptor[] descriptor = Introspector.getBeanInfo(ServoPort.class).getPropertyDescriptors();

            for (int i = 0; i < descriptor.length; i++) {
                PropertyDescriptor propertyDescriptor = descriptor[i];
                if (propertyDescriptor.getName().equals("status")) {
                    propertyDescriptor.setValue("transient", Boolean.TRUE);
                }
            }
        }
        catch (IntrospectionException e) {
            throw new RuntimeException(e);
        }
    }

    private int dimMax = 0;

    private int dimMin = 0;

    private int pwmMax = 0;

    private int pwmMin = 0;

    public LightPort() {
        setStatus(LightPortStatus.ON);
    }

    public int getDimMax() {
        return dimMax;
    }

    public void setDimMax(int dimMax) {
        this.dimMax = dimMax;
    }

    public int getDimMin() {
        return dimMin;
    }

    public void setDimMin(int dimMin) {
        this.dimMin = dimMin;
    }

    public int getPwmMax() {
        return pwmMax;
    }

    public void setPwmMax(int pwmMax) {
        this.pwmMax = pwmMax;
    }

    public int getPwmMin() {
        return pwmMin;
    }

    public void setPwmMin(int pwmMin) {
        this.pwmMin = pwmMin;
    }

    public static LightPort load(String fileName) {
        LightPort result = null;
        XMLDecoder d = null;

        try {
            try {
                d = new XMLDecoder(new GZIPInputStream(new BufferedInputStream(new FileInputStream(fileName))));

                result = (LightPort) d.readObject();
            }
            catch (IOException e) {
                d = new XMLDecoder(new BufferedInputStream(new FileInputStream(fileName)));

                result = (LightPort) d.readObject();
            }
        }
        catch (FileNotFoundException e) {
        }
        finally {
            if (d != null) {
                d.close();
            }
        }
        return result;
    }

    public void save(String fileName) throws IOException {
        XMLEncoder e = new XMLEncoder(new GZIPOutputStream(new BufferedOutputStream(new FileOutputStream(fileName))));

        e.writeObject(this);
        e.close();
    }
}
