package org.bidib.wizard.mvc.main.model.function;

import org.bidib.wizard.comm.LightPortStatus;
import org.bidib.wizard.mvc.main.model.LightPort;

public class LightPortAction extends PortAction {
    public LightPortAction() {
        setAction(LightPortStatus.ON);
    }

    public LightPortAction(LightPortStatus action, int delay, LightPort port) {
        setAction(action);
        setDelay(delay);
        setPort(port);
    }

    public LightPortStatus getAction() {
        return (LightPortStatus) super.getAction();
    }

    public void setAction(LightPortStatus action) {
        super.setAction(action);
    }

    public LightPort getPort() {
        return (LightPort) super.getPort();
    }

    public void setPort(LightPort port) {
        super.setPort(port);
    }

    public String getDebugString() {
        int id = 0;

        if (getPort() != null) {
            id = getPort().getId();
        }
        return "@" + getDelay() + " L-Port:" + String.format("%02d", id) + "->" + getAction().name().toLowerCase();
    }
}
