package org.bidib.wizard.mvc.main.view.menu;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Collection;
import java.util.LinkedList;

import javax.swing.JMenuItem;

import org.bidib.wizard.locale.Resources;
import org.bidib.wizard.mvc.main.view.menu.listener.LabelListMenuListener;

public class PortListMenu extends MyPopupMenu {
    private static final long serialVersionUID = -1177960721928132834L;

    private final Collection<LabelListMenuListener> menuListeners = new LinkedList<LabelListMenuListener>();

    public PortListMenu() {
        JMenuItem editLabel = new JMenuItem(Resources.getString(getClass(), "editLabel") + " ...");

        editLabel.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                fireEditLabel();
            }
        });
        add(editLabel);
    }

    public void addMenuListener(LabelListMenuListener l) {
        menuListeners.add(l);
    }

    private void fireEditLabel() {
        for (LabelListMenuListener l : menuListeners) {
            l.editLabel();
        }
    }
}
