package org.bidib.wizard.mvc.main.view.panel;

import javax.swing.table.TableColumn;

import org.bidib.wizard.comm.AnalogPortStatus;
import org.bidib.wizard.locale.Resources;
import org.bidib.wizard.mvc.main.model.MainModel;
import org.bidib.wizard.mvc.main.model.SimplePortTableModel;
import org.bidib.wizard.mvc.main.view.table.ComboBoxWithButtonEditor;
import org.bidib.wizard.mvc.main.view.table.ComboBoxWithButtonRenderer;

public class AnalogPortListPanel extends SimplePortListPanel {
    private static final long serialVersionUID = 8170545473738112762L;

    public AnalogPortListPanel(MainModel model) {
        super(new SimplePortTableModel(), model.getAnalogPorts(), Resources.getString(AnalogPortListPanel.class,
            "emptyTable"));
        model.addAnalogPortListListener(this);

        TableColumn buttonColumn = table.getColumnModel().getColumn(table.getColumnCount() - 1);

        buttonColumn.setCellRenderer(new ComboBoxWithButtonRenderer(table.getActions(AnalogPortStatus.START), ">"));
        buttonColumn.setCellEditor(new ComboBoxWithButtonEditor(table.getActions(AnalogPortStatus.START), ">"));
    }
}
