package org.bidib.wizard.mvc.main.view.panel;

import org.bidib.wizard.locale.Resources;
import org.bidib.wizard.mvc.main.model.FeedbackPortTableModel;
import org.bidib.wizard.mvc.main.model.MainModel;
import org.bidib.wizard.mvc.main.view.table.FeedbackPortTableCellRenderer;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class FeedbackPortListPanel extends SimplePortListPanel {
    private static final Logger LOGGER = LoggerFactory.getLogger(FeedbackPortListPanel.class);

    private static final long serialVersionUID = 854313416949782538L;

    public FeedbackPortListPanel(MainModel model) {
        super(new FeedbackPortTableModel(model), model.getFeedbackPorts(), Resources.getString(
            FeedbackPortListPanel.class, "emptyTable"));

        LOGGER.debug("Create new FeedbackPortListPanel.");

        for (int index = 0; index < table.getColumnCount(); index++) {
            table.getColumnModel().getColumn(index).setCellRenderer(new FeedbackPortTableCellRenderer());
        }

        table.setRowHeight(80);
        table.setTableHeader(null);
        model.addFeedbackPortListListener(this);
    }

    @Override
    public void listChanged() {
        LOGGER.debug("List has changed, remove all rows and add rows again.");
        tableModel.setRowCount(0);
        ((FeedbackPortTableModel) tableModel).addRow(ports);
    }
}
