package org.bidib.wizard.mvc.main.view.panel;

import org.bidib.wizard.locale.Resources;
import org.bidib.wizard.mvc.main.model.InputPortTableModel;
import org.bidib.wizard.mvc.main.model.MainModel;
import org.bidib.wizard.mvc.main.model.Port;
import org.bidib.wizard.mvc.main.model.listener.OutputListener;
import org.bidib.wizard.mvc.main.model.listener.PortListener;
import org.bidib.wizard.mvc.main.view.table.InputPortTableCellRenderer;

public class InputPortListPanel extends SimplePortListPanel {
    private static final long serialVersionUID = 319299637116737381L;

    public InputPortListPanel(MainModel model) {
        super(new InputPortTableModel(model), model.getInputPorts(), Resources.getString(InputPortListPanel.class,
            "emptyTable"));
        if (table.getColumnCount() > 1) {
            table.getColumnModel().getColumn(1).setCellRenderer(new InputPortTableCellRenderer());
        }
        model.addInputPortListListener(this);
    }

    public void addPortListener(final PortListener l) {
        super.addPortListener(new OutputListener() {
            @Override
            public void labelChanged(Port port, String value) {
                l.labelChanged(port, value);
            }

            @Override
            public void statusChanged(Port port, Enum<?> status) {
            }

            @Override
            public void testButtonPressed(Port output) {
            }
        });
    }
}
