package org.bidib.wizard.mvc.main.view.panel;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JPanel;

import org.bidib.wizard.mvc.main.model.StatusModel;
import org.bidib.wizard.mvc.main.view.panel.listener.StatusListener;

public class StatusPanel extends JPanel {
    private static final long serialVersionUID = 6259235698654221621L;

    private final StatusButtonPanel statusButtonPanel;

    public StatusPanel(StatusModel model) {
        setLayout(new GridBagLayout());

        GridBagConstraints c = new GridBagConstraints();

        c.anchor = GridBagConstraints.LINE_START;
        c.fill = GridBagConstraints.BOTH;
        c.gridx = 0;
        c.insets = new Insets(5, 5, 5, 5);
        c.weightx = 0.2;
        c.weighty = 1;
        statusButtonPanel = new StatusButtonPanel(model);
        add(statusButtonPanel, c);

        c.anchor = GridBagConstraints.CENTER;
        c.gridx++;
        c.weightx = 0.7;
        add(new LedPanel(model), c);

        c.anchor = GridBagConstraints.LINE_END;
        c.gridx++;
        c.weightx = 0.1;
        add(new TimePanel(model), c);
    }

    public void addStatusListener(StatusListener l) {
        statusButtonPanel.addStatusListener(l);
    }
}
