package org.bidib.wizard.mvc.main.view.panel;

import javax.swing.table.TableColumn;

import org.bidib.wizard.comm.SwitchPortStatus;
import org.bidib.wizard.locale.Resources;
import org.bidib.wizard.mvc.main.model.MainModel;
import org.bidib.wizard.mvc.main.model.SimplePortTableModel;
import org.bidib.wizard.mvc.main.view.table.ComboBoxWithButtonEditor;
import org.bidib.wizard.mvc.main.view.table.ComboBoxWithButtonRenderer;

public class SwitchPortListPanel extends SimplePortListPanel {
    private static final long serialVersionUID = 3911630096196450993L;

    public SwitchPortListPanel(MainModel model) {
        super(new SimplePortTableModel(), model.getSwitchPorts(), Resources.getString(SwitchPortListPanel.class,
            "emptyTable"));
        model.addSwitchPortListListener(this);

        TableColumn buttonColumn = table.getColumnModel().getColumn(table.getColumnCount() - 1);

        buttonColumn.setCellRenderer(new ComboBoxWithButtonRenderer(table.getActions(SwitchPortStatus.ON), ">"));
        buttonColumn.setCellEditor(new ComboBoxWithButtonEditor(table.getActions(SwitchPortStatus.ON), ">"));
    }
}
