package org.bidib.wizard.mvc.main.view.table;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.border.Border;
import javax.swing.table.DefaultTableCellRenderer;

import org.bidib.wizard.comm.InputPortStatus;
import org.bidib.wizard.mvc.main.model.Port;

public class InputPortTableCellRenderer extends DefaultTableCellRenderer {
    private static final long serialVersionUID = -2765309661630191498L;

    public Component getTableCellRendererComponent(
        JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
        JPanel result = new JPanel();
        GridBagLayout layout = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();

        c.fill = GridBagConstraints.CENTER;
        layout.setConstraints(result, c);
        result.setLayout(layout);

        JLabel label = new JLabel();
        Border b = BorderFactory.createRaisedBevelBorder();

        label.setBorder(b);

        Object status = ((Port) value).getStatus();

        if ((InputPortStatus) status == InputPortStatus.ON) {
            label.setBackground(Color.RED);
        }
        label.setOpaque(true);
        label.setPreferredSize(new Dimension(15, 15));
        result.add(label);
        return result;
    }
}