package org.bidib.wizard.mvc.main.view.table;

import java.awt.Point;
import java.awt.event.MouseEvent;

import javax.swing.JPanel;
import javax.swing.table.TableModel;

import org.bidib.wizard.locale.Resources;
import org.bidib.wizard.mvc.main.model.Port;

public class PortTable extends MyTable {
    private static final long serialVersionUID = -1538239025203576704L;

    public PortTable(TableModel dm, String emptyTableText) {
        super(dm, emptyTableText);
        setRowHeight(((JPanel) new SliderEditor().getTableCellRendererComponent(this, 1, false, false, 0, 0))
            .getPreferredSize().height);
    }

    public String getToolTipText(MouseEvent e) {
        String result = null;
        Point p = e.getPoint();
        int row = rowAtPoint(p);
        int column = columnAtPoint(p);

        if (row >= 0 && column == 0 && getModel().getRowCount() > 0 && getModel().getColumnCount() > 0) {
            Object port = getModel().getValueAt(row, getModel().getColumnCount() - 1);

            if (port != null && port instanceof Port
                && (((Port) port).getLabel() == null || ((Port) port).getLabel().isEmpty())) {
                result = Resources.getString(MyTable.class, "chooseLabel");
            }
        }
        return result;
    }
}
