package org.bidib.wizard.mvc.main.view.table;

import java.util.ArrayList;
import java.util.List;

public class TwoDimensionalArray<E> {
    private final ArrayList<ArrayList<E>> array = new ArrayList<ArrayList<E>>();

    public E get(int row, int column) {
        E result = null;

        if (row >= 0 && row < array.size()) {
            ArrayList<E> columnArray = array.get(row);

            if (column >= 0 && column <= columnArray.size()) {
                result = columnArray.get(column);
            }
        }
        return result;
    }

    private void resize(List<?> l, int size) {
        for (int index = 1; index <= size; index++) {
            if (l.size() < index) {
                l.add(null);
            }
        }
    }

    public void set(E value, int row, int column) {
        ArrayList<E> columnArray = null;

        if (row >= 0 && row < array.size()) {
            columnArray = array.get(row);
        }
        else {
            columnArray = new ArrayList<E>();
            resize(array, row);
            array.add(row, columnArray);
        }
        resize(columnArray, column);
        columnArray.add(column, value);
    }
}
