package org.bidib.wizard.mvc.preferences.model;

import java.util.Collection;
import java.util.HashSet;
import java.util.LinkedList;

import org.bidib.wizard.mvc.preferences.model.listener.PreferencesModelListener;

public class PreferencesModel {
    private final Collection<PreferencesModelListener> listeners = new LinkedList<PreferencesModelListener>();

    private final Collection<CommPort> commPorts = new HashSet<CommPort>();

    public void addPreferencesModelListener(PreferencesModelListener l) {
        listeners.add(l);
    }

    private void fireCommPortsChanged() {
        for (PreferencesModelListener l : listeners) {
            l.commPortsChanged();
        }
    }

    public Collection<CommPort> getCommPorts() {
        return commPorts;
    }

    public void setCommPorts(Collection<CommPort> commPorts) {
        this.commPorts.clear();
        this.commPorts.addAll(commPorts);
        fireCommPortsChanged();
    }
}
